# std::vector< _Tp, _Alloc > Class Template Reference
[Containers, Sequences]

Inheritance diagram for std::vector< _Tp, _Alloc >:

List of all members.

## Detailed Description

### template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
class std::vector< _Tp, _Alloc >

A standard container which offers fixed time access to individual elements in any order.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the exception of `push_front` and `pop_front`.

In some terminology a vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( ``[] ) access is also provided as with C-style arrays.

Definition at line 175 of file stl_vector.h.

## Public Types

- typedef _Alloc allocator_type
- typedef __gnu_cxx::__normal_iterator<
  const_pointer, vector_type > const_iterator
- typedef _Tp_alloc_type::const_pointer const_pointer
- typedef _Tp_alloc_type::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef ptrdiff_t difference_type
- typedef __gnu_cxx::__normal_iterator<
  pointer, vector_type > iterator
- typedef _Tp_alloc_type::pointer pointer
- typedef _Tp_alloc_type::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef size_t size_type
- typedef _Tp value_type

## Public Member Functions

- template<typename _InputIterator> void assign (_InputIterator __first, _InputIterator __last)
- void assign (size_type __n, const value_type &__val)
- const_reference at (size_type __n) const
- reference at (size_type __n)
- const_reference back () const
- reference back ()
- const_iterator begin () const
- iterator begin ()
- size_type capacity () const
- void clear ()
- const_pointer data () const
- pointer data ()
- bool empty () const
- const_iterator end () const
- iterator end ()
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- const_reference front () const
- reference front ()
- template<typename _InputIterator> void insert (iterator __position, _InputIterator __first, _InputIterator __last)
- void insert (iterator __position, size_type __n, const value_type &__x)
- iterator insert (iterator __position, const value_type &__x)
- size_type max_size () const
- vector & operator= (const vector &__x)
- const_reference operator[] (size_type __n) const
- reference operator[] (size_type __n)
- void pop_back ()
- void push_back (const value_type &__x)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- void reserve (size_type __n)
- void resize (size_type __new_size, value_type __x=value_type())
- size_type size () const
- void swap (vector &__x)
- template<typename _InputIterator> vector (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
- vector (const vector &__x)
- vector (size_type __n, const value_type &__value=value_type(), const allocator_type &__a=allocator_type())
- vector (const allocator_type &__a)
- vector ()
- ~vector ()

## Protected Member Functions

- _Tp * _M_allocate (size_t __n)
- template<typename _ForwardIterator> pointer _M_allocate_and_copy (size_type __n, _ForwardIterator __first, _ForwardIterator __last)
- template<typename _ForwardIterator> void _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator> void _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- template<typename _InputIterator> void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
- size_type _M_check_len (size_type __n, const char *__s) const
- void _M_deallocate (_Tp *__p, size_t __n)
- void _M_erase_at_end (pointer __pos)
- void _M_fill_assign (size_type __n, const value_type &__val)
- void _M_fill_initialize (size_type __n, const value_type &__value)
- void _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
- const _Tp_alloc_type & _M_get_Tp_allocator () const
- _Tp_alloc_type & _M_get_Tp_allocator ()
- template<typename _InputIterator> void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_initialize_dispatch (_Integer __n, _Integer __value, __true_type)
- void _M_insert_aux (iterator __position, const value_type &__x)
- template<typename _InputIterator> void _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __val, __true_type)
- void _M_range_check (size_type __n) const
- template<typename _ForwardIterator> void _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator> void _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- template<typename _ForwardIterator> void _M_range_insert (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator> void _M_range_insert (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- allocator_type get_allocator () const

## Protected Attributes

- _Vector_impl _M_impl

## Constructor & Destructor Documentation

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::vector< _Tp, _Alloc >::vector | ( |  | ) | `[inline]`

Default constructor creates no elements.

Definition at line 213 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::vector< _Tp, _Alloc >::vector | ( | const allocator_type & | __a | ) | `[inline, explicit]`

Creates a vector with no elements.

Parameters:

  | a | An allocator object.

Definition at line 221 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::vector< _Tp, _Alloc >::vector | ( | size_type | __n,
|  | const value_type & | __value = `value_type()`,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline, explicit]`

Creates a vector with copies of an exemplar element.

Parameters:

  | n | The number of elements to initially create.
  | value | An element to copy.
  | a | An allocator.

This constructor fills the vector with n copies of value.

Definition at line 233 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::vector< _Tp, _Alloc >::vector | ( | const vector< _Tp, _Alloc > & | __x | ) | `[inline]`

Vector copy constructor.

Parameters:

  | x | A vector of identical element and allocator types.

The newly-created vector uses a copy of the allocation object used by x. All the elements of x are copied, but any extra memory in x (for fast expansion) will not be copied.

Definition at line 247 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

std::vector< _Tp, _Alloc >::vector | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline]`

Builds a vector from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | a | An allocator.

Create a vector consisting of copies of the elements from [first,last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 284 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::vector< _Tp, _Alloc >::~vector | ( |  | ) | `[inline]`

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 299 of file stl_vector.h.

## Member Function Documentation

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _ForwardIterator>

pointer std::vector< _Tp, _Alloc >::_M_allocate_and_copy | ( | size_type | __n,
|  | _ForwardIterator | __first,
|  | _ForwardIterator | __last |
| ) |  |  | `[inline, protected]`

Memory expansion handler. Uses the member allocation function to obtain n bytes of memory, and then copies [first,last) into it.

Definition at line 901 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::_M_assign_aux(), and std::vector< _Tp, _Alloc >::operator=().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::_M_range_check | ( | size_type | __n | ) | const`[inline, protected]`

Safety check used only from at().

Definition at line 583 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

void std::vector< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Assigns a range to a vector.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

This function fills a vector with copies of the elements in the range [first,last).

Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 360 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val |
| ) |  |  | `[inline]`

Assigns a given value to a vector.

Parameters:

  | n | Number of elements to be assigned.
  | val | Value to be assigned.

This function fills a vector with n copies of the given value. Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 343 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::vector< _Tp, _Alloc >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the vector.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 620 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::vector< _Tp, _Alloc >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the vector.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 602 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::vector< _Tp, _Alloc >::back | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the last element of the vector.

Definition at line 655 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::vector< _Tp, _Alloc >::back | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the last element of the vector.

Definition at line 647 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::vector< _Tp, _Alloc >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first element in the vector. Iteration is done in ordinary element order.

Reimplemented in std::match_results< _Bi_iter, _Allocator >, and std::match_results< _Bi_iter >.

Definition at line 386 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::vector< _Tp, _Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first element in the vector. Iteration is done in ordinary element order.

Definition at line 377 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::_M_fill_assign(), std::vector< bool, _Alloc >::_M_fill_insert(), std::vector< bool, _Alloc >::_M_insert_aux(), std::vector< bool, _Alloc >::_M_insert_range(), std::vector< _Tp, _Alloc >::insert(), __gnu_parallel::multiseq_partition(), __gnu_parallel::multiseq_selection(), __gnu_parallel::multiway_merge_4_combined(), std::vector< _Tp, _Alloc >::operator=(), std::vector< bool, _Alloc >::operator=(), std::operator==(), __gnu_parallel::parallel_multiway_merge(), std::vector< bool, _Alloc >::reserve(), std::vector< std::sub_match< _Bi_iter >, _Allocator >::vector(), and std::vector< bool, _Alloc >::vector().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::vector< _Tp, _Alloc >::capacity | ( |  | ) | const`[inline]`

Returns the total number of elements that the vector can hold before needing to allocate more memory.

Definition at line 517 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::_M_assign_aux(), std::vector< _Tp, _Alloc >::_M_fill_assign(), std::vector< bool, _Alloc >::_M_fill_insert(), std::vector< bool, _Alloc >::_M_insert_range(), and std::vector< _Tp, _Alloc >::operator=().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::clear | ( |  | ) | `[inline]`

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 891 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

pointer std::vector< _Tp, _Alloc >::data | ( |  | ) | `[inline]`

Returns a pointer such that [data(), data() + size()) is a valid range. For a non-empty vector, data() == &front().

Definition at line 666 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

bool std::vector< _Tp, _Alloc >::empty | ( |  | ) | const`[inline]`

Returns true if the vector is empty. (Thus begin() would equal end().)

Reimplemented in std::match_results< _Bi_iter, _Allocator >, and std::match_results< _Bi_iter >.

Definition at line 526 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::vector< _Tp, _Alloc >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last element in the vector. Iteration is done in ordinary element order.

Reimplemented in std::match_results< _Bi_iter, _Allocator >, and std::match_results< _Bi_iter >.

Definition at line 404 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::vector< _Tp, _Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last element in the vector. Iteration is done in ordinary element order.

Definition at line 395 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::_M_assign_aux(), std::vector< _Tp, _Alloc >::_M_fill_assign(), std::vector< bool, _Alloc >::_M_fill_insert(), std::vector< _Tp, _Alloc >::_M_fill_insert(), std::vector< bool, _Alloc >::_M_insert_aux(), std::vector< bool, _Alloc >::_M_insert_range(), std::vector< _Tp, _Alloc >::_M_range_insert(), std::vector< _Tp, _Alloc >::erase(), std::vector< _Tp, _Alloc >::insert(), __gnu_parallel::multiseq_partition(), __gnu_parallel::multiseq_selection(), __gnu_parallel::multiway_merge_4_combined(), std::vector< _Tp, _Alloc >::operator=(), std::vector< bool, _Alloc >::operator=(), std::operator==(), std::vector< bool, _Alloc >::reserve(), std::vector< std::sub_match< _Bi_iter >, _Allocator >::vector(), and std::vector< bool, _Alloc >::vector().

template<typename _Tp, typename _Alloc>

vector< _Tp, _Alloc >::iterator vector::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  |

Remove a range of elements.

Parameters:

  | first | Iterator pointing to the first element to be erased.
  | last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the vector accordingly.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 133 of file vector.tcc.

References _GLIBCXX_MOVE3, std::vector< _Tp, _Alloc >::_M_erase_at_end(), __gnu_cxx::__normal_iterator< _Iterator, _Container >::base(), and std::vector< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc>

vector< _Tp, _Alloc >::iterator vector::erase | ( | iterator | __position | ) |

Remove element at given position.

Parameters:

  | position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the vector by one.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 121 of file vector.tcc.

References _GLIBCXX_MOVE3, std::_Vector_base< _Tp, _Alloc >::_M_impl, and std::vector< _Tp, _Alloc >::end().

Referenced by __gnu_parallel::multiway_merge_4_combined().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::vector< _Tp, _Alloc >::front | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the first element of the vector.

Definition at line 639 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::vector< _Tp, _Alloc >::front | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the first element of the vector.

Definition at line 631 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

void std::vector< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Inserts a range into the vector.

Parameters:

  | position | An iterator into the vector.
  | first | An input iterator.
  | last | An input iterator.

This function will insert copies of the data in the range [first,last) into the vector before the location specified by pos.

Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 810 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x |
| ) |  |  | `[inline]`

Inserts a number of copies of given data into the vector.

Parameters:

  | position | An iterator into the vector.
  | n | Number of elements to be inserted.
  | x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 791 of file stl_vector.h.

template<typename _Tp, typename _Alloc>

vector< _Tp, _Alloc >::iterator vector::insert | ( | iterator | __position,
|  | const value_type & | __x |
| ) |  |  |

Inserts given value into vector before specified iterator.

Parameters:

  | position | An iterator into the vector.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 94 of file vector.tcc.

References std::_Vector_base< _Tp, _Alloc >::_M_impl, std::vector< _Tp, _Alloc >::_M_insert_aux(), std::vector< _Tp, _Alloc >::begin(), and std::vector< _Tp, _Alloc >::end().

Referenced by std::vector< _Tp, _Alloc >::_M_assign_aux(), std::vector< _Tp, _Alloc >::_M_range_insert(), and __gnu_parallel::multiway_merge_4_combined().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::vector< _Tp, _Alloc >::max_size | ( |  | ) | const`[inline]`

Returns the size() of the largest possible vector.

Definition at line 489 of file stl_vector.h.

template<typename _Tp, typename _Alloc>

vector< _Tp, _Alloc > & vector::operator= | ( | const vector< _Tp, _Alloc > & | __x | ) |

Vector assignment operator.

Parameters:

  | x | A vector of identical element and allocator types.

All the elements of x are copied, but any extra memory in x (for fast expansion) will not be copied. Unlike the copy constructor, the allocator object is not copied.

Definition at line 144 of file vector.tcc.

References std::__uninitialized_copy_a(), std::_Destroy(), std::vector< _Tp, _Alloc >::_M_allocate_and_copy(), std::_Vector_base< _Tp, _Alloc >::_M_deallocate(), std::_Vector_base< _Tp, _Alloc >::_M_get_Tp_allocator(), std::_Vector_base< _Tp, _Alloc >::_M_impl, std::vector< _Tp, _Alloc >::begin(), std::vector< _Tp, _Alloc >::capacity(), std::vector< _Tp, _Alloc >::end(), and std::vector< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::vector< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const`[inline]`

Subscript access to the data contained in the vector.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Reimplemented in std::match_results< _Bi_iter >.

Definition at line 577 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::vector< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | `[inline]`

Subscript access to the data contained in the vector.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 562 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::pop_back | ( |  | ) | `[inline]`

Removes last element.

This is a typical stack operation. It shrinks the vector by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 722 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) | `[inline]`

Add data to the end of the vector.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the vector and assigns the given data to it. Due to the nature of a vector this operation can be done in constant time if the vector has preallocated space available.

Definition at line 686 of file stl_vector.h.

Referenced by __gnu_parallel::multiseq_partition(), and __gnu_parallel::multiseq_selection().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::vector< _Tp, _Alloc >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.

Definition at line 422 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::vector< _Tp, _Alloc >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.

Definition at line 413 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::vector< _Tp, _Alloc >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.

Definition at line 440 of file stl_vector.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::vector< _Tp, _Alloc >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.

Definition at line 431 of file stl_vector.h.

template<typename _Tp, typename _Alloc>

void vector::reserve | ( | size_type | __n | ) |

Attempt to preallocate enough memory for specified number of elements.

Parameters:

  | n | Number of elements required.

Exceptions:

  | std::length_error | If n exceeds `max_size()`.

This function attempts to reserve enough memory for the vector to hold the specified number of elements. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the number of elements that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of vector data.

Definition at line 70 of file vector.tcc.

References __N, std::_Destroy(), and _GLIBCXX_MAKE_MOVE_ITERATOR.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | value_type | __x = `value_type()` |
| ) |  |  | `[inline]`

Resizes the vector to the specified number of elements.

Parameters:

  | new_size | Number of elements the vector should contain.
  | x | Data with which new elements should be populated.

This function will resize the vector to the specified number of elements. If the number is smaller than the vector's current size the vector is truncated, otherwise the vector is extended and new elements are populated with given data.

Definition at line 504 of file stl_vector.h.

Referenced by __gnu_parallel::parallel_multiway_merge(), and __gnu_parallel::shrink_and_double().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::vector< _Tp, _Alloc >::size | ( |  | ) | const`[inline]`

Returns the number of elements in the vector.

Reimplemented in std::match_results< _Bi_iter, _Allocator >, and std::match_results< _Bi_iter >.

Definition at line 484 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::_M_assign_aux(), std::vector< _Tp, _Alloc >::_M_fill_assign(), std::vector< bool, _Alloc >::_M_fill_insert(), std::vector< bool, _Alloc >::_M_insert_range(), __gnu_cxx::hashtable< _Val, _Key, _HashFcn, _ExtractKey, _EqualKey, _Alloc >::clear(), __gnu_cxx::hashtable< _Val, _Key, _HashFcn, _ExtractKey, _EqualKey, _Alloc >::equal_range(), __gnu_cxx::hashtable< _Val, _Key, _HashFcn, _ExtractKey, _EqualKey, _Alloc >::erase(), __gnu_parallel::list_partition(), std::vector< _Tp, _Alloc >::operator=(), std::vector< bool, _Alloc >::operator=(), std::operator==(), __gnu_cxx::hashtable< _Val, _Key, _HashFcn, _ExtractKey, _EqualKey, _Alloc >::resize(), __gnu_parallel::shrink(), __gnu_parallel::shrink_and_double(), and std::vector< bool, _Alloc >::vector().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::vector< _Tp, _Alloc >::swap | ( | vector< _Tp, _Alloc > & | __x | ) | `[inline]`

Swaps data with another vector.

Parameters:

  | x | A vector of the same element and allocator types.

This exchanges the elements between two vectors in constant time. (Three pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(v1,v2) will feed to this function.

Definition at line 870 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::_M_fill_assign(), __gnu_cxx::hashtable< _Val, _Key, _HashFcn, _ExtractKey, _EqualKey, _Alloc >::resize(), and std::swap().

The documentation for this class was generated from the following files:

- stl_vector.h
- vector.tcc